program ArchiTekaSE;

uses
  Forms,
  Sysutils,
  Windows,
  ClientMain in 'ClientMain.pas' {frmClientMain},
  SearchMain in 'SearchMain.pas' {frmSearchMain},
  SearchList in '..\ArchiTekaSE\SearchList.pas' {frmSearchList},
  ServerConsts in '..\Archi-Teka\Source\Server\ServerConsts.pas',
  ArchiverMain in 'ArchiverMain.pas' {frmArchiverMain},
  ClientConsts in '..\Archi-Teka\Source\Client\ClientConsts.pas',
  ClientMainDataModule in 'ClientMainDataModule.pas' {dmClientMain: TDataModule},
  MailsAndFaxes in 'MailsAndFaxes.pas' {frmMailsAndFaxes},
  HuYesNoDialog in 'HuYesNoDialog.pas' {frmHuYesNoDialog},
  ArchiverMainDataModule in 'ArchiverMainDataModule.pas' {dmArchiverMain: TDataModule};

{$R *.RES}

begin
  with Application do
  Begin
    try
      Initialize;
      CreateForm(TdmClientMain, dmClientMain);
      dmClientMain.Authentication;
      CreateForm(TdmArchiverMain, dmArchiverMain);
      CreateForm(TfrmClientMain, frmClientMain);
      CreateForm(TfrmSearchMain, frmSearchMain);
      CreateForm(TfrmSearchList, frmSearchList);
      CreateForm(TfrmArchiverMain, frmArchiverMain);
      CreateForm(TfrmMailsAndFaxes, frmMailsAndFaxes);
    except
        On E:EPrivilege do
        Begin
          Application.MessageBox(pChar(E.message),'Hiba',MB_OK);
          Application.Terminate;
        End;
        On E:EAssertionFailed do
        Begin
          Application.Terminate;
        End;
    end;
    Run;
  End;
end.
