unit ClientMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ToolWin, ComCtrls, StdCtrls, Buttons, Mask, ImgList, ExtCtrls, ActnList,
  Menus, Db, ADODB, DBCtrls, Grids, DBGrids;

type

  TFieldNameCaptions = record  //(Component Tag mezje/lista Data pointerbe trolt rekord) vlasztja ki melyik rekordot hasznlja
    Caption:string;            //Megjelentett nv
    FilterText:string;         //Trolt eljrsnak tadott, Format fgvnnyel formzott szr
    AlternateFilterText:string;//Trolt eljrsnak tadott, Format fgvnnyel formzott szr null rtkekhez
    FieldType:integer;         //Mez tpus
    Mask:string;               //Beviteli maszk a MaskEdit-hez
    DisplayScript:string;      //Begpelskor fut keres script
    DisplayField:string;       //Begpelskor megjelen mez neve
    KeyField:string;           //Begpels utn eltrolt mez neve
    Relations:string;
    ParamName:string;
    MultiSelect:boolean;       //Tbbet is kivllaszthat-e
  end;

  TFilterFieldValues = record
    FieldIndex:integer;
    DisplayValue:string;
    FieldValue:string;
    DisplayValueHigh:string;
    FieldValueHigh:string;
    Relation:string;
  End;
  pTFilterFieldValues = ^TFilterFieldValues;

  TfrmClientMain = class(TForm)
    StatusBar: TStatusBar;
    pcData: TPageControl;
    ToolBar1: TToolBar;
    Splitter1: TSplitter;
    ImageList1: TImageList;
    ActionList1: TActionList;
    actNewDocument: TAction;
    actSearch: TAction;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    miExport: TMenuItem;
    ToolButton3: TToolButton;
    miSearch: TMenuItem;
    TabSheet1: TTabSheet;
    pcRegisterTable: TPageControl;
    tsDocument: TTabSheet;
    dbgItems: TDBGrid;
    Label21: TLabel;
    Label22: TLabel;
    Bevel6: TBevel;
    Label31: TLabel;
    tsClerk: TTabSheet;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Bevel7: TBevel;
    Bevel8: TBevel;
    dbtIncomingDate: TDBText;
    dbtIncomingClerkName: TDBText;
    dbtIncomingClerkOrganizationUnitName: TDBText;
    dbtRegisterDate: TDBText;
    dbtRegisterClerkName: TDBText;
    dbtRegisterClerkOrganizationUnitName: TDBText;
    dbtClerkName: TDBText;
    dbtClerkOrganizationUnitName: TDBText;
    dbtSubject: TDBText;
    dbtDocumentKind: TDBText;
    dbtDocumentType: TDBText;
    Label1: TLabel;
    DBText1: TDBText;
    Label2: TLabel;
    DBText2: TDBText;
    Label5: TLabel;
    DBText3: TDBText;
    Label6: TLabel;
    DBText4: TDBText;
    Label7: TLabel;
    DBText5: TDBText;
    Bevel1: TBevel;
    Label8: TLabel;
    Label44: TLabel;
    DBText6: TDBText;
    Bevel5: TBevel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    DBText8: TDBText;
    DBText7: TDBText;
    Bevel11: TBevel;
    Label48: TLabel;
    Label49: TLabel;
    DBText9: TDBText;
    DBText10: TDBText;
    Label50: TLabel;
    Label51: TLabel;
    DBText11: TDBText;
    DBText12: TDBText;
    tsDescription: TTabSheet;
    tsDynamic: TTabSheet;
    Panel1: TPanel;
    Panel2: TPanel;
    Label52: TLabel;
    Label53: TLabel;
    DBRichEdit1: TDBRichEdit;
    DBRichEdit2: TDBRichEdit;
    Label62: TLabel;
    TabSheet2: TTabSheet;
    sgDynamicDatas: TStringGrid;
    Label4: TLabel;
    Label9: TLabel;
    dbtDocumentIncomingBook: TDBText;
    dbtDocumentRegisterBook: TDBText;
    N2: TMenuItem;
    miExit: TMenuItem;
    pmFilter: TPopupMenu;
    pmModify: TMenuItem;
    pmDelete: TMenuItem;
    pmAdd: TMenuItem;
    Panel3: TPanel;
    Panel4: TPanel;
    lbListSearch: TListBox;
    lbListDestination: TListBox;
    rbAllDocumentType: TRadioButton;
    edtDocumentType: TEdit;
    rbDocumentType: TRadioButton;
    Label3: TLabel;
    Panel5: TPanel;
    chxFiltered: TCheckBox;
    Splitter2: TSplitter;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    actArchiver: TAction;
    actViewArchive: TAction;
    Archivls1: TMenuItem;
    actViewArchive1: TMenuItem;
    actExport: TAction;
    procedure actSearchExecute(Sender: TObject);
    procedure dbgItemsDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure FilterFieldChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edtDocumentTypeEnter(Sender: TObject);
    procedure edtDocumentTypeExit(Sender: TObject);
    procedure edtDocumentTypeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ExchangeFilterItem(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ChangeValue(Sender: TObject);
    procedure rbAllDocumentTypeClick(Sender: TObject);
    procedure chxFilteredClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure pmModifyClick(Sender: TObject);
    procedure pmAddDeleteClick(Sender: TObject);
    procedure lbExit(Sender: TObject);
    procedure miExitClick(Sender: TObject);
    procedure lbDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtDocumentTypeDblClick(Sender: TObject);
    procedure edtDocumentTypeKeyPress(Sender: TObject; var Key: Char);
    procedure dbgItemsDblClick(Sender: TObject);
    procedure dbgItemsKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure pcDataChange(Sender: TObject);
    procedure actArchiverExecute(Sender: TObject);
    procedure actViewArchiveExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FLocated,
    NotInSearch:boolean;
    FSearchListDisplayed:boolean;
    FDocumentTypeID:Integer;
    procedure PrepareValueForm(AFilterFieldValues:pTFilterFieldValues;AFieldNameCaptions:TFieldNameCaptions);
    procedure PrepareValue(AFilterFieldValues:pTFilterFieldValues;AFieldNameCaptions:TFieldNameCaptions);
    procedure PrepareDynamicFields(Sender:TObject);
    procedure RemoveDynamicFields;
  end;

var
  frmClientMain: TfrmClientMain;
  DinamicFields:array of TFieldNameCaptions;

const
  CStrRel = '='#13#10'~'#13#10'!~'#13#10'<>'#13#10''#13#10'!';
  CIntRel = '='#13#10'<'#13#10'>'#13#10'<>'#13#10'<='#13#10'>='#13#10''#13#10'!'#13#10'><';
  CIDRel = '='#13#10''#13#10'!';
  COrderBy = 'DocumentRegister.DocumentRegisterBookID,DocumentRegister.RegisteringNumber,DocumentRegister.SubNumber';
  CName='isNull(LastName+'#39' '#39','#39#39')+isNull(MiddleName+'#39' '#39','#39#39')+isNull(FirstName,'#39#39')';

  CTableFields : array [0..16] of TFieldNameCaptions =
  ((Caption:'Iktatknyv';  FilterText:'DocumentRegister.DocumentRegisterBookID %s %s'; AlternateFilterText:'';
    FieldType:varString; Mask:''; DisplayScript:'Select %s from DocumentRegisterBook order by DocumentRegisterBook'; DisplayField:'DocumentRegisterBook'; KeyField:'DocumentRegisterBookID';
    Relations:CIDRel; ParamName:'@RegisterFilter'; MultiSelect:false),

   (Caption:'Iktatszm';   FilterText:'DocumentRegister.RegisteringNumber %s %s';      AlternateFilterText:'';
    FieldType:varInteger; Mask:''; DisplayScript:''; DisplayField:''; KeyField:'';
    Relations:CIntRel; ParamName:'@RegisterFilter'; MultiSelect:false),

   (Caption:'Alszm';       FilterText:'DocumentRegister.SubNumber %s %s';              AlternateFilterText:'';
    FieldType:varInteger; Mask:''; DisplayScript:''; DisplayField:''; KeyField:'';
    Relations:CIntRel; ParamName:'@RegisterFilter'; MultiSelect:false),

   (Caption:'Archive index';       FilterText:'Document.ArchivIndex %s %s';              AlternateFilterText:'';
    FieldType:varInteger; Mask:''; DisplayScript:''; DisplayField:''; KeyField:'';
    Relations:CIntRel; ParamName:'@FinalFilter'; MultiSelect:false),

   (Caption:'Kapcsolattart';   FilterText:'Customer.CustomerID %s %s'; AlternateFilterText:'';
    FieldType:varString; Mask:''; DisplayScript:'Select %s from Customer where LastName != '#39'ismeretlen'#39' order by '+CName; DisplayField:CName+' as CustomerName'; KeyField:'CustomerID';
    Relations:CIDRel; ParamName:'@FinalFilter'; MultiSelect:false),

   (Caption:'rkeztetsi szm';       FilterText:'DocumentIncoming.IncomingNumber %s %s'; AlternateFilterText:'';
    FieldType:varInteger; Mask:''; DisplayScript:''; DisplayField:''; KeyField:'';
    Relations:CIntRel; ParamName:'@IncomingFilter'; MultiSelect:false),

   (Caption:'Trgy';   FilterText:'Subject.SubjectID %s %s'; AlternateFilterText:'';
    FieldType:varString; Mask:''; DisplayScript:'Select %s from Subject order by Subject'; DisplayField:'Subject'; KeyField:'SubjectID';
    Relations:CIDRel; ParamName:'@FinalFilter'; MultiSelect:false),

   (Caption:'Irattri ttel';   FilterText:'FilingType.FilingTypeID %s %s'; AlternateFilterText:'';
    FieldType:varString; Mask:''; DisplayScript:'Select %s from FilingType order by FilingType'; DisplayField:'FilingType'; KeyField:'FilingTypeID';
    Relations:CIDRel; ParamName:'@FinalFilter'; MultiSelect:false),

   (Caption:'Iktats dtuma';   FilterText:'CONVERT(DateTime,FLOOR(CONVERT(Float,DocumentActionDiary.[DateTime]))) %s %s'; AlternateFilterText:'DocumentActionDiary.[DateTime] %s %s';
    FieldType:varDate; Mask:''; DisplayScript:''; DisplayField:''; KeyField:'';
    Relations:CIntRel; ParamName:'@RegisterFilter'; MultiSelect:false),

   (Caption:'Elintzsi hatrid';   FilterText:'CONVERT(DateTime,FLOOR(CONVERT(Float,DocumentRegister.[DateOfDispatch]))) %s %s'; AlternateFilterText:'DocumentRegister.[DateOfDispatch] %s %s';
    FieldType:varDate; Mask:''; DisplayScript:''; DisplayField:''; KeyField:'';
    Relations:CIntRel; ParamName:'@RegisterFilter'; MultiSelect:false),

   (Caption:'Elintzs dtuma';   FilterText:'CONVERT(DateTime,FLOOR(CONVERT(Float,DocumentRegister.[DispatchDate]))) %s %s'; AlternateFilterText:'DocumentRegister.[DispatchDate] %s %s';
    FieldType:varDate; Mask:''; DisplayScript:''; DisplayField:''; KeyField:'';
    Relations:CIntRel; ParamName:'@RegisterFilter'; MultiSelect:false),

   (Caption:'Szervezeti egysg iktatknyvei';   FilterText:'DocumentRegisterBook.OrganizationUnitID %s %s'; AlternateFilterText:'';
    FieldType:varString; Mask:''; DisplayScript:'Select %s from OrganizationUnit order by OrganizationUnit'; DisplayField:'OrganizationUnit'; KeyField:'OrganizationUnitID';
    Relations:CIDRel; ParamName:'@RegisterFilter'; MultiSelect:false),

   (Caption:'Iktats megjegyzs';   FilterText:'LOWER(CONVERT(varchar(8000),DocumentRegister.Description)) %s LOWER(CONVERT(varchar(8000),%s))'; AlternateFilterText:'DocumentRegister.Description %s %s';
    FieldType:varString; Mask:''; DisplayScript:''; DisplayField:''; KeyField:'';
    Relations:CStrRel; ParamName:'@RegisterFilter'; MultiSelect:false),

   (Caption:'gyintz szervezeti egysge';   FilterText:'OrganizationUnit.OrganizationUnitID %s %s'; AlternateFilterText:'';
    FieldType:varString; Mask:''; DisplayScript:'Select %s from OrganizationUnit order by OrganizationUnit'; DisplayField:'OrganizationUnit'; KeyField:'OrganizationUnitID';
    Relations:CIDRel; ParamName:'@FinalFilter'; MultiSelect:false),

   (Caption:'Cgnv';   FilterText:'Company.CompanyID %s %s'; AlternateFilterText:'';
    FieldType:varString; Mask:''; DisplayScript:'Select %s from Company order by Company'; DisplayField:'Company'; KeyField:'CompanyID';
    Relations:CIDRel; ParamName:'@FinalFilter'; MultiSelect:false),

   (Caption:'Irny';   FilterText:'DocumentKind.DocumentKindID %s %s'; AlternateFilterText:'';
    FieldType:varString; Mask:''; DisplayScript:'Select %s from DocumentKind order by DocumentKind'; DisplayField:'DocumentKind'; KeyField:'DocumentKindID';
    Relations:CIDRel; ParamName:'@FinalFilter'; MultiSelect:false),

   (Caption:'gyintz';   FilterText:'DocumentRegister.ClerkID %s %s'; AlternateFilterText:'';
    FieldType:varString; Mask:''; DisplayScript:'Select %s from Clerk order by '+CName; DisplayField:CName+' as ClerkName'; KeyField:'ClerkID';
    Relations:CIDRel; ParamName:'@ClerkFilter'; MultiSelect:false));
implementation

uses SearchMain, SearchList, ClientMainDataModule, ArchiverMain,
  ArchiverMainDataModule, ZLib, HuYesNoDialog;

{$R *.DFM}


procedure TfrmClientMain.actSearchExecute(Sender: TObject);
var cv:integer;
    lvFieldNameCaptions:TFieldNameCaptions;
    lvparam:string;
begin
  try
    Screen.Cursor:=crSQLWait;

    with dmClientMain.dstSearchDocumentRegisterData do
    Begin
      Close;
      for cv:=0 to Parameters.Count-1 do
        Parameters[cv].Value:=null;
    End;

    with sgDynamicDatas do
    Begin
      Cols[0].Clear;
      Cols[1].Clear;
      RowCount:=2
    End;

    with lbListDestination do
    Begin
      if chxFiltered.Checked then
        for cv:=0 to items.Count-1 do
        with pTFilterFieldValues(Items.Objects[cv])^ do
        Begin
          if FieldIndex<0 then
            lvFieldNameCaptions:=DinamicFields[(FieldIndex*-1)-1]
          else
            lvFieldNameCaptions:=CTableFields[FieldIndex];

          with lvFieldNameCaptions do
          Begin
            if Relation='' then
            Begin
              if AlternateFilterText<>'' then
                lvparam:=Format(AlternateFilterText,['is null',''])
              else
                lvparam:=Format(FilterText,['is null',''])
            end
            else
            if Relation='!' then
            Begin
              if AlternateFilterText<>'' then
                lvparam:=Format(AlternateFilterText,['is not null',''])
              else
                lvparam:=Format(FilterText,['is not null',''])
            end
            else
            if Relation='><' then
            Begin
              if (FieldType=varDate) then
                lvparam:=Format(FilterText,['between',#39+FieldValue+#39' and '#39+FieldValueHigh+#39])
              else
                lvparam:=Format(FilterText,['between',FieldValue+' and '+FieldValueHigh])
            End
            else
            Begin
              if (FieldType=varDate) then
                lvparam:=Format(FilterText,[Relation,#39+FieldValue+#39])
              else
              if (FieldType=varString) then
                lvparam:=Format(FilterText,[StringReplace(StringReplace(Relation,'~','like',[rfReplaceAll]),'!','not ',[rfReplaceAll]),#39+StringReplace(FieldValue,'*','%',[rfReplaceAll])+#39])
              else
                lvparam:=Format(FilterText,[Relation,FieldValue]);
            End;

            with dmClientMain do
            if VarIsNull(dstSearchDocumentRegisterData.Parameters.ParamByName(ParamName).Value) then
              dstSearchDocumentRegisterData.Parameters.ParamByName(ParamName).Value:=lvparam
            else
              dstSearchDocumentRegisterData.Parameters.ParamByName(ParamName).Value:=
                dstSearchDocumentRegisterData.Parameters.ParamByName(ParamName).Value+' and '+lvparam;
          End;
        End;

      if FLocated then
        dmClientMain.dstSearchDocumentRegisterData.Parameters.ParamByName('@DocTypeFilterTable').Value:='['+edtDocumentType.Text+']';

      dmClientMain.dstSearchDocumentRegisterData.Parameters.ParamByName('@OrderBy').Value:=COrderBy;
      dmClientMain.dstSearchDocumentRegisterData.Open;
      StatusBar.Panels.Items[0].Text:='Szmll: '+
        IntToStr(dmClientMain.dstSearchDocumentRegisterData.RecordCount)+' db.'
    End;
  finally
    Screen.Cursor:=crDefault;
  end;
end;

procedure TfrmClientMain.dbgItemsDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
  if not VarIsNull(dmClientMain.dstSearchDocumentRegisterData.FieldByName('Attributes').Value) and
    (Integer(dmClientMain.dstSearchDocumentRegisterData.FieldByName('Attributes').Value[15]) in [1,3]) and
    not (gdFixed in State) then
    with Sender as TDBGrid do
    begin
      Canvas.Pen.Width:=1;
      Canvas.Pen.Color:=clRed;
      Canvas.MoveTo(Rect.Left,Rect.Top+(Rect.Bottom-Rect.Top) div 2);
      Canvas.LineTo(Rect.Right,Rect.Top+(Rect.Bottom-Rect.Top) div 2);
      Canvas.Pen.Color:=clBlack;
    end;
end;

procedure TfrmClientMain.FormShow(Sender: TObject);
var cv:integer;
    lvFilterFieldValues:pTFilterFieldValues;
begin
  FLocated:=false;
  FDocumentTypeID:=-1;
  NotInSearch:=True;
  pcData.ActivePageIndex:=0;
  pcRegisterTable.ActivePageIndex:=0;
  rbAllDocumentType.Checked:=True;
  with lbListSearch do
    for cv:=0 to Length(CTableFields)-1 do
    Begin
      New(lvFilterFieldValues);
      lvFilterFieldValues^.FieldIndex:=cv;
      Items.AddObject(CTableFields[cv].Caption,TObject(lvFilterFieldValues));
    End;
end;

procedure TfrmClientMain.edtDocumentTypeEnter(Sender: TObject);
begin
  with dmClientMain.dsSearch do
  try
    Close;
    CommandText:='Select DocumentTypeID,DocumentType from DocumentType';
    Open;
    Fields[0].Visible:=false;
    FLocated:=Locate('DocumentType',TEdit(Sender).Text,[loCaseInsensitive,loPartialKey])
  except
  end;
end;

procedure TfrmClientMain.FilterFieldChange(Sender: TObject);
var lvSelStart:integer;
begin
  with dmClientMain do
  if TWinControl(Sender).Focused and NotInSearch then
  Begin
    rbDocumentType.Checked:=True;
    if dsSearch.Active then
    try
      FLocated:=dsSearch.Locate('DocumentType',TEdit(Sender).Text,[loCaseInsensitive,loPartialKey]);
      if FLocated then
      Begin
        NotInSearch:=False;
        lvSelStart:=TEdit(Sender).SelStart;
        TEdit(Sender).Text:=dsSearch.FieldByName('DocumentType').asString;
        TEdit(Sender).SelStart:=lvSelStart;
        TEdit(Sender).SelLength:=Length(TEdit(Sender).Text)-lvSelStart;
        NotInSearch:=True;
      End;
    except
      NotInSearch:=True;
      FLocated:=False;
    end;
  End;
end;

procedure TfrmClientMain.edtDocumentTypeExit(Sender: TObject);
begin
  if FLocated then
  Begin
    PrepareDynamicFields(Sender);
    dmClientMain.dsSearch.Close;
  End
  else
  if edtDocumentType.Text<>'' then
  Begin
    edtDocumentType.SetFocus;
    if (FDocumentTypeID>0) then
      RemoveDynamicFields;
  End
  else
  Begin
    if FDocumentTypeID>0 then
      RemoveDynamicFields;
    rbAllDocumentType.Checked:=True;
    dmClientMain.dstSearchDocumentRegisterData.Parameters.ParamByName('@DocTypeFilterTable').Value:='';
    dmClientMain.dsSearch.Close;
  End;
end;

procedure TfrmClientMain.edtDocumentTypeKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key=VK_UP then
  Begin
    FLocated:=False;
    NotInSearch:=False;
    edtDocumentType.Text:='';
    NotInSearch:=True;
    rbAllDocumentType.Checked:=True;
    rbAllDocumentType.SetFocus;
  End
  else
  if Key=VK_RETURN then
  Begin
    edtDocumentType.SelStart:=0;
    edtDocumentType.SelLength:=Length(edtDocumentType.Text);
    if FLocated then
      PrepareDynamicFields(edtDocumentType);
  End
  else
  if Key=VK_BACK then
  with Sender as TEdit do
  Begin
    if (SelStart>0) and (SelLength>0) then
    Begin
      SelStart:=SelStart-1;
      SelLength:=Length(Text)-SelStart;
    End;
  End
  else
  if (ssCtrl in Shift) and (Key=VK_SPACE) then
  with frmSearchList do
  Begin
    frmSearchList.NotInSearch:=False;
    edtSearch.Text:=edtDocumentType.Text;
    FSelStart:=edtDocumentType.SelStart;
    FSelLength:=edtDocumentType.SelLength;
    frmSearchList.NotInSearch:=True;
    FDisplayField:='DocumentType';
    FSearchListDisplayed:=True;
    if ShowModal=mrOK then
    Begin
      frmClientMain.NotInSearch:=False;
      edtDocumentType.Text:=edtSearch.Text;
      edtDocumentType.SelStart:=edtSearch.SelStart;
      edtDocumentType.SelLength:=edtSearch.SelLength;
      frmClientMain.NotInSearch:=True;
      frmClientMain.FLocated:=frmSearchList.FLocated;
      rbDocumentType.Checked:=True;
      PrepareDynamicFields(edtDocumentType);
    End
    else
      FLocated:=frmSearchMain.LocateText(edtDocumentType,'DocumentType');
    FSearchListDisplayed:=false;
  End;
end;

procedure TfrmClientMain.ExchangeFilterItem(Sender: TObject);
var lvFieldNameCaptions:TFieldNameCaptions;
    cv:integer;
begin
  if TListBox(Sender).ItemIndex>-1 then
  try
    with TListBox(Sender),pTFilterFieldValues(Items.Objects[ItemIndex])^ do
    if FieldIndex<0 then
      lvFieldNameCaptions:=DinamicFields[(FieldIndex*-1)-1]
    else
      lvFieldNameCaptions:=CTableFields[FieldIndex];

    if Sender=lbListSearch then
    With lbListSearch do
    Begin
      PrepareValueForm(pTFilterFieldValues(Items.Objects[ItemIndex]),lvFieldNameCaptions);
      frmSearchMain.meValue.Text:='';
      frmSearchMain.meRangeHigh.Text:='';
      if frmSearchMain.ShowModal=mrOK then
      Begin
        PrepareValue(pTFilterFieldValues(Items.Objects[ItemIndex]),lvFieldNameCaptions);
        with pTFilterFieldValues(Items.Objects[ItemIndex])^,lvFieldNameCaptions do
        if Relation='><' then
          lbListDestination.Items.AddObject(DisplayValue+' <= '+Caption+' <= '+DisplayValueHigh,Items.Objects[ItemIndex])
        else
          lbListDestination.Items.AddObject(Caption+' '+Relation+' '+DisplayValue,Items.Objects[ItemIndex]);
        cv:=ItemIndex;
        Items.Delete(ItemIndex);
        if cv>Items.Count-1 then
          ItemIndex:=Items.Count-1
        else
          ItemIndex:=cv;
      End;
      dmClientMain.dsSearch.Close;
    End
    else
    Begin
      With lbListDestination,lvFieldNameCaptions do
      Begin
        lbListSearch.Items.AddObject(Caption,Items.Objects[ItemIndex]);
        cv:=ItemIndex;
        Items.Delete(ItemIndex);
        if (cv=0) and lbListSearch.Enabled and (lbListDestination.Items.Count=0) then
        Begin
          lbListSearch.SetFocus;
          lbListSearch.ItemIndex:=0;
        End
        else
        if cv>Items.Count-1 then
          ItemIndex:=Items.Count-1
        else
          ItemIndex:=cv;
      End
    End;
  except
    ShowException(ExceptObject,ExceptAddr);
  end;
end;

procedure TfrmClientMain.FormClose(Sender: TObject;
  var Action: TCloseAction);
var cv:integer;
begin
  with lbListSearch do
    for cv:=0 to Items.Count-1 do
    if assigned(Items.Objects[cv]) then
    Begin
      Dispose(pTFilterFieldValues(Items.Objects[cv]));
      Items.Objects[cv]:=nil;
    End;

  with lbListDestination do
    for cv:=0 to Items.Count-1 do
    if assigned(Items.Objects[cv]) then
    Begin
      Dispose(pTFilterFieldValues(Items.Objects[cv]));
      Items.Objects[cv]:=nil;
    End;
end;

procedure TfrmClientMain.PrepareValueForm(AFilterFieldValues:pTFilterFieldValues;AFieldNameCaptions:TFieldNameCaptions);
var lvAsPos:integer;
begin
  with AFilterFieldValues^,AFieldNameCaptions,frmSearchMain do
  Begin
    lblFieldCaption.Caption:=AFieldNameCaptions.Caption;
    meValue.EditMask:=Mask;
    meRangeHigh.EditMask:=Mask;
    dmClientMain.dsSearch.Close;
    if DisplayScript<>'' then
    Begin
      dmClientMain.dsSearch.CommandText:=Format(DisplayScript,[KeyField+','+DisplayField]);
      dmClientMain.dsSearch.Open;
    End;
    lvAsPos:=pos(' as ',DisplayField);
    if lvAsPos>0 then
      frmSearchMain.FDisplayField:=copy(DisplayField,lvAsPos+4,Length(DisplayField))
    else
      frmSearchMain.FDisplayField:=DisplayField;

    if DisplayScript<>'' then
    Begin
      dmClientMain.dsSearch.Fields.FieldByName(FDisplayField).DisplayLabel:=lblFieldCaption.Caption;
      dmClientMain.dsSearch.Fields.FieldByName(KeyField).Visible:=false;
    End;

    cbxRelations.Items.Text:=Relations;
    cbxRelations.ItemIndex:=0;
    FFieldType:=FieldType;
    meValue.Text:='';
    meRangeHigh.Text:='';
    if FieldType=varDate then
    Begin
      meRangeHigh.Enabled:=False;
      meValue.Enabled:=False;
      dtpTo.Date:=Date;
      dtpTo.Enabled:=True;
      dtpTo.BringToFront;
      dtpFrom.Enabled:=True;
      dtpFrom.BringToFront;
      dtpFrom.Date:=Date;
      ActiveControl:=dtpFrom;
    End
    else
    Begin
      dtpTo.Enabled:=False;
      dtpFrom.Enabled:=False;
      meRangeHigh.Enabled:=True;
      meRangeHigh.BringToFront;
      meValue.Enabled:=True;
      meValue.BringToFront;
      ActiveControl:=meValue;
    End;
  End;
end;

procedure TfrmClientMain.ChangeValue(Sender: TObject);
var lvFieldNameCaptions:TFieldNameCaptions;
begin
  With lbListDestination do
  if ItemIndex>-1 then
  Begin
    with pTFilterFieldValues(Items.Objects[ItemIndex])^ do
    if FieldIndex<0 then
      lvFieldNameCaptions:=DinamicFields[(FieldIndex*-1)-1]
    else
      lvFieldNameCaptions:=CTableFields[FieldIndex];

    PrepareValueForm(pTFilterFieldValues(Items.Objects[ItemIndex]),lvFieldNameCaptions);
    with pTFilterFieldValues(Items.Objects[ItemIndex])^,frmSearchMain,lvFieldNameCaptions do
    Begin
      cbxRelations.ItemIndex:=frmSearchMain.cbxRelations.Items.IndexOf(Relation);
      if FieldType=varDate then
      try
        dtpFrom.Date:=StrToDate(DisplayValue);
        dtpTo.Date:=StrToDate(DisplayValueHigh);
      except
      end
      else
      Begin
        meValue.Text:=DisplayValue;
        meRangeHigh.Text:=DisplayValueHigh;
      End;
    End;

    if frmSearchMain.ShowModal=mrOK then
    Begin
      PrepareValue(pTFilterFieldValues(Items.Objects[ItemIndex]),lvFieldNameCaptions);
      with pTFilterFieldValues(Items.Objects[ItemIndex])^,lvFieldNameCaptions do
        if Relation='><' then
          lbListDestination.Items[ItemIndex]:=DisplayValue+' <= '+Caption+' <= '+DisplayValueHigh
        else
          lbListDestination.Items[ItemIndex]:=Caption+' '+Relation+' '+DisplayValue;
    End;
    dmClientMain.dsSearch.Close;
  End
end;

procedure TfrmClientMain.RemoveDynamicFields;
var cv:integer;
begin
  with lbListSearch do
  for cv:=Items.Count-1 downto 0 do
    if pTFilterFieldValues(Items.Objects[cv])^.FieldIndex<0 then
    Begin
      Dispose(pTFilterFieldValues(Items.Objects[cv]));
      Items.Delete(cv);
    End;

  with lbListDestination do
  for cv:=Items.Count-1 downto 0 do
    if pTFilterFieldValues(Items.Objects[cv])^.FieldIndex<0 then
    Begin
      Dispose(pTFilterFieldValues(Items.Objects[cv]));
      Items.Delete(cv);
    End;
  FDocumentTypeID:=-1;
end;

procedure TfrmClientMain.rbAllDocumentTypeClick(Sender: TObject);
begin
  if TWinControl(Sender).Focused then
  Begin
    if FDocumentTypeID>0 then
      RemoveDynamicFields;
    FLocated:=False;
    edtDocumentType.Text:='';
  End;
end;

procedure TfrmClientMain.PrepareValue(AFilterFieldValues:pTFilterFieldValues;AFieldNameCaptions:TFieldNameCaptions);
begin
  with AFilterFieldValues^,AFieldNameCaptions,frmSearchMain do
  Begin
    if (cbxRelations.Text='') or (cbxRelations.Text='!')then
    Begin
      DisplayValue:='';
      DisplayValueHigh:='';
      FieldValue:='';
      FieldValueHigh:='';
    End
    else
    if FieldType<>varDate then
    Begin
      DisplayValue:=trim(meValue.Text);
      DisplayValueHigh:=trim(meRangeHigh.Text);
      if DisplayField<>'' then
      Begin
        FieldValue:=trim(dmClientMain.dsSearch.FieldByName(KeyField).asString);
        FieldValueHigh:='';
      End
      else
      Begin
        FieldValue:=trim(meValue.Text);
        FieldValueHigh:=trim(meRangeHigh.Text);
      End;
    End
    else
    Begin
      DisplayValue:=FormatDateTime('yyyy.mm.dd',dtpFrom.date);
      DisplayValueHigh:=FormatDateTime('yyyy.mm.dd',dtpTo.date);
      FieldValue:=DisplayValue;
      FieldValueHigh:=DisplayValueHigh;
    End;
    Relation:=cbxRelations.Text;
  End;
end;

procedure TfrmClientMain.chxFilteredClick(Sender: TObject);
begin
  lbListSearch.Enabled:=chxFiltered.Checked;
  lbListDestination.Enabled:=chxFiltered.Checked;
end;

procedure TfrmClientMain.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift) then
  Begin
    case key of
      48..52: //Ctrl+0..4 0 - keress  1-4 Nzetflek
              Begin
                pcData.ActivePageIndex:=49-(48+Integer(key>48));
                pcRegisterTable.ActivePageIndex:=key-49+Integer(key=48);
                pcDataChange(pcData);
              End;
          82: //Ctrl+R Ttelek grid
                dbgItems.SetFocus;
          87: //Ctrl+Q Keressi felttelek Jobb ablak
              Begin
                pcData.ActivePageIndex:=1;
                lbListDestination.Enabled:=True;
                lbListDestination.Enabled:=True;
                chxFiltered.Checked:=True;
                lbListDestination.SetFocus;
                if lbListDestination.Items.Count>0 then
                  lbListDestination.ItemIndex:=0;
              End;
          81: //Ctrl+W Keressi felttelek Ball ablak
              Begin
                pcData.ActivePageIndex:=1;
                lbListSearch.Enabled:=True;
                lbListSearch.Enabled:=True;
                chxFiltered.Checked:=True;
                lbListSearch.SetFocus;
                if lbListSearch.Items.Count>0 then
                  lbListSearch.ItemIndex:=0;
              End;
          68: //Ctrl+D Dokumentum Tpus
              Begin
                pcData.ActivePageIndex:=1;
                rbDocumentType.Checked:=True;
                edtDocumentType.SetFocus;
              End;
    end;
  End
  else
  if (ssAlt in Shift) then
  Begin
    if Key=VK_RETURN then
      if WindowState=wsNormal then
        WindowState:=wsMaximized
      else
        WindowState:=wsNormal;
  End;
end;

procedure TfrmClientMain.lbContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
  pmModify.Visible:=Sender=lbListDestination;
  pmDelete.Visible:=Sender=lbListDestination;
  pmAdd.Visible:=Sender=lbListSearch;
  TListBox(Sender).ItemIndex:=TListBox(Sender).ItemAtPos(MousePos,true);
  Handled:=TListBox(Sender).ItemIndex=-1;
end;

procedure TfrmClientMain.pmModifyClick(Sender: TObject);
begin
  ChangeValue(pmFilter.PopupComponent);
end;

procedure TfrmClientMain.pmAddDeleteClick(Sender: TObject);
begin
  ExchangeFilterItem(pmFilter.PopupComponent);
end;

procedure TfrmClientMain.lbExit(Sender: TObject);
begin
  TListBox(Sender).ItemIndex:=-1;
end;

procedure TfrmClientMain.miExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmClientMain.lbDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Key=VK_DELETE) and (Sender=lbListDestination) then
    ExchangeFilterItem(Sender)
  else
  if (Key=VK_RETURN) then
  Begin
    if (Sender=lbListSearch) then
      ExchangeFilterItem(Sender)
    else
      ChangeValue(Sender);
  End;
end;

procedure TfrmClientMain.edtDocumentTypeDblClick(Sender: TObject);
var Key:word;
begin
  Key:=VK_SPACE;
  edtDocumentTypeKeyDown(edtDocumentType,Key,[ssCtrl]);
end;

procedure TfrmClientMain.edtDocumentTypeKeyPress(Sender: TObject;
  var Key: Char);
begin
  if FSearchListDisplayed then
    key:=#0
end;

procedure TfrmClientMain.dbgItemsDblClick(Sender: TObject);
begin
  pcData.ActivePageIndex:=0;
  pcRegisterTable.ActivePageIndex:=0;
end;

procedure TfrmClientMain.dbgItemsKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=VK_RETURN then
  Begin
    pcData.ActivePageIndex:=0;
    pcRegisterTable.ActivePageIndex:=0;
  End;
end;

procedure TfrmClientMain.PrepareDynamicFields(Sender: TObject);
var cv:integer;
   lvFilterFieldValues:pTFilterFieldValues;
begin
  if (FDocumentTypeID<>dmClientMain.dsSearch.FieldByName('DocumentTypeID').asInteger) then
  with dmClientMain.spGetDocumentTypeFields do
  Begin
    if FDocumentTypeID>0 then
      RemoveDynamicFields;
    cv:=0;
    FDocumentTypeID:=dmClientMain.dsSearch.FieldByName('DocumentTypeID').asInteger;
    Close;
    Parameters.ParamByName('@DocumentTypeID').Value:=FDocumentTypeID;
    Open;
    SetLength(DinamicFields,RecordCount);
    while not EOF do
    Begin
      New(lvFilterFieldValues);
      lvFilterFieldValues^.FieldIndex:=(cv+1)*-1;
      DinamicFields[cv].Caption:='['+edtDocumentType.Text+'].['+FieldByName('DisplayText').asString+']';
      lbListSearch.Items.AddObject(DinamicFields[cv].Caption,TObject(lvFilterFieldValues));
      DinamicFields[cv].DisplayField:='';
      DinamicFields[cv].DisplayScript:='';
      DinamicFields[cv].KeyField:=FieldByName('DocumentTypeField').asString;
      case dmClientMain.spGetDocumentTypeFieldsFieldTypeID.asInteger of
        1,2:
          Begin
            DinamicFields[cv].FieldType:=varString;
            DinamicFields[cv].Relations:=CStrRel;
            DinamicFields[cv].FilterText:='['+edtDocumentType.Text+'].['+DinamicFields[cv].KeyField+'] %s %s';
          End;
        3,5:
          Begin
            DinamicFields[cv].FieldType:=varInteger;
            DinamicFields[cv].Relations:=CIntRel;
            DinamicFields[cv].FilterText:='['+edtDocumentType.Text+'].['+DinamicFields[cv].KeyField+'] %s %s';
          End;
        4:
          Begin
            DinamicFields[cv].FieldType:=varDate;
            DinamicFields[cv].Relations:=CIntRel;
          End;
      End;
      DinamicFields[cv].Mask:='';
      DinamicFields[cv].MultiSelect:=false;
      DinamicFields[cv].ParamName:='@DocTypeFilter';
      Next;
      inc(cv);
    End;
    Close;
  End;
end;

procedure TfrmClientMain.pcDataChange(Sender: TObject);
begin
  if pcData.ActivePageIndex=0 then
    dbgItems.SetFocus
  else
    chxFiltered.SetFocus;
end;

procedure TfrmClientMain.actArchiverExecute(Sender: TObject);
var lvDocumentID:Variant;
begin
  frmArchiverMain.FArchivExist:=not dmClientMain.dstSearchDocumentRegisterData.FieldByName('ArchivIndex').isNull;
  if frmArchiverMain.FArchivExist then
  Begin
    if not assigned(frmHuYesNoDialog) then
      Application.CreateForm(TfrmHuYesNoDialog,frmHuYesNoDialog);
    frmHuYesNoDialog.lbMessage.Caption:='Az archiv anyag ltezik.'#13#10'Kvn j verzit ltrehozni?';
    if frmHuYesNoDialog.ShowModal=mrCancel then
      exit;
  End;
  frmArchiverMain.lvFiles.Items.Clear;
  if frmArchiverMain.ShowModal=mrOK then
  Begin
    lvDocumentID:=dmClientMain.dstSearchDocumentRegisterData.FieldByName('DocumentID').Value;
    actSearch.Execute;
    dmClientMain.dstSearchDocumentRegisterData.Locate('DocumentID',lvDocumentID,[]);
  End;
end;

procedure TfrmClientMain.actViewArchiveExecute(Sender: TObject);
var SFS,DFS,NFS:TStream;
    UZFS:TDecompressionStream;
    lvItemSize:Integer;
    lvFileName:string;
    lvReadCount:Integer;
    lvListItem:TListItem;
    cv:integer;
    lvDocumentID:Variant;
begin
  try
    with dmArchiverMain do
    Begin
      dmClientMain.dsGetDocumentStoreName.Close;
      dmClientMain.dsGetDocumentStoreName.Parameters.ParamByName('@DSID').Value:=dmClientMain.dstSearchDocumentRegisterData.FieldByName('DocumentStoreID').Value;
      dmClientMain.dsGetDocumentStoreName.Open;
      cmdUseDB.CommandText:='Use ['+dmClientMain.dsGetDocumentStoreName.FieldByName('DocumentStore').Value+']';
      dmClientMain.dsGetDocumentStoreName.Close;
      cmdUseDB.Execute;
      dsSelectArchivData.Close;
      dsSelectArchivData.Parameters.ParamByName('@ArchivIndex').Value:=dmClientMain.dstSearchDocumentRegisterData.FieldByName('ArchivIndex').Value;
      dsSelectArchivData.Open;
      cmdUseDB.CommandText:='Use ['+dmClientMain.MasterDatabase+']';
      cmdUseDB.Execute;
      SFS:=dsSelectArchivData.CreateBlobStream(dsSelectArchivData.FieldByName('ArchivData'),bmRead);
      if SFS.Size=0 then
        raise Exception.Create('Archv anyag olvassi hiba.'); 
    End;
    UZFS:=TDecompressionStream.Create(SFS);
    NFS:=TStringStream.Create('');
    frmArchiverMain.lvFiles.Items.Clear;
    UZFS.ReadBuffer(lvReadCount,sizeOf(lvReadCount));
    for cv:=1 to lvReadCount do
    try
      UZFS.ReadBuffer(lvItemSize,sizeOf(lvItemSize));
      SetLength(lvFileName,lvItemSize);
      NFS.Seek(0,soFromBeginning);
      NFS.CopyFrom(UZFS,lvItemSize);
      NFS.Seek(0,soFromBeginning);
      NFS.ReadBuffer(Pointer(lvFileName)^,lvItemSize);
      DFS:=TFileStream.Create(dmClientMain.TempFilePath+lvFileName,fmCreate);
      UZFS.ReadBuffer(lvItemSize,sizeOf(lvItemSize));
      DFS.CopyFrom(UZFS,lvItemSize);
      lvListItem:=frmArchiverMain.lvFiles.Items.Add;
      lvListItem.Caption:=lvFileName;
      lvListItem.SubItems.Add(dmClientMain.TempFilePath);
      lvListItem.ImageIndex:=frmArchiverMain.AddIcon(dmClientMain.TempFilePath+lvFileName);
    finally
      FreeAndNil(DFS);
    End;
  finally
    FreeAndNil(NFS);
    FreeAndNil(UZFS);
    FreeAndNil(SFS);
    dmArchiverMain.dsSelectArchivData.Close;
  end;
  with frmArchiverMain,lvFiles do
  Begin
    FArchivExist:=True;
    ImgThumbnail.Image:='';
    imgEdit.ClearDisplay;
    if ShowModal = mrOK then
    Begin
      lvDocumentID:=dmClientMain.dstSearchDocumentRegisterData.FieldByName('DocumentID').Value;
      actSearch.Execute;
      dmClientMain.dstSearchDocumentRegisterData.Locate('DocumentID',lvDocumentID,[]);
    End;
    for cv:=0 to Items.Count-1 do
    begin
      if Items.Item[cv].SubItems.Strings[0]=dmClientMain.TempFilePath then
        DeleteFile(Items.Item[cv].SubItems.Strings[0]+Items.Item[cv].Caption);
    end;
  End;
end;

end.
